package hay.app;

import java.io.FileInputStream;
import android.app.PendingIntent;
import android.app.PendingIntent.CanceledException;
import android.content.BroadcastReceiver;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.media.AudioManager;
import android.media.SoundPool;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Vibrator;
import android.telephony.gsm.SmsMessage;
import android.util.Log;
import android.widget.Toast;

public class SmsReceiver extends BroadcastReceiver {
	public static final Uri MMS_SMS_CONTENT_URI = Uri.parse("content://mms-sms/");
	public static final Uri THREAD_ID_CONTENT_URI =
		Uri.withAppendedPath(MMS_SMS_CONTENT_URI, "threadID");
	String str = "";
	SoundPool pool;
	String body;
	long date;
	int data;

	private static final String ACTION_MMS_RECEIVED = "android.provider.Telephony.WAP_PUSH_RECEIVED";

	public void onReceive(final Context context, Intent intent) {
		Bundle bundle = intent.getExtras();

		SmsMessage[] msgs = null;
		String action = intent.getAction(); 
		String dataType = intent.getType(); 
		// MMS ϰ 
		if ( ACTION_MMS_RECEIVED.equals(action)) 
		{  
			Toast.makeText(context, "MMS ޽ ŵǾϴ.", 0).show();
		} else { 
			//SMS ϰ
			if (bundle != null) {
				Object[] pdus = (Object[]) bundle.get("pdus");
				msgs = new SmsMessage[pdus.length];
				for (int i = 0; i < msgs.length; i++) {
					msgs[i] = SmsMessage.createFromPdu((byte[]) pdus[i]);
					str =msgs[i].getOriginatingAddress();//  ǹ
					body=msgs[i].getDisplayMessageBody();
					date=msgs[i].getTimestampMillis();
				}


			}


			final Intent i = new Intent(context, HaySmsDetail.class);
			AudioManager am = (AudioManager)context.getSystemService(Context.AUDIO_SERVICE);
			switch(am.getRingerMode())
			{//϶
			case AudioManager.RINGER_MODE_SILENT:
				break;
				//϶
			case AudioManager.RINGER_MODE_VIBRATE:

				Vibrator vibe = (Vibrator) context.getSystemService(Context.VIBRATOR_SERVICE);
				vibe.vibrate(500);
				break;
				//Ϲݸ϶
			case AudioManager.RINGER_MODE_NORMAL:

				Vibrator vibe2 = (Vibrator) context.getSystemService(Context.VIBRATOR_SERVICE);
				vibe2.vibrate(500);
				//			MediaPlayer mp = MediaPlayer.create(context, R.raw.alarm);
				//			am.setStreamVolume(AudioManager.STREAM_MUSIC,am.getStreamMaxVolume(AudioManager.STREAM_MUSIC), 0);
				//			mp.start();
				break;
			}
			Log.d("hay","aaaa");
			final Build a = new Build();

			// ڸ޽ Ž HaySmsDetail ȣ ٴ Ʈؼ ̾ȵǴµ.*/
			Handler handler = new Handler();
			handler.postDelayed(
					new Runnable() {
						public void run() {

							int flag = str.indexOf(";");

							if (flag!=-1)
								str= str.substring(0,flag);

							i.putExtra("contact_number",str );

							i.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);


							// S,Aϰ
							if(a.MODEL.toString().compareTo("SHW-M100S")==0 |a.MODEL.toString().compareTo("SHW-M110S")==0){ 
								Cursor cursor2 = null;
								Log.d("hay","fuck null");
								cursor2 = context.getContentResolver().query(Uri.parse("content://sms/inbox"),
										null, null, null, null);

								String sbody=null;
								Log.d("hay","if null");

								//cursor2.moveToFirst();
								if(!(cursor2.moveToNext())){
									Log.d("hay","not sms");

									ContentValues val = new ContentValues();
									val.put("address",str);
									val.put("date",date );
									val.put("read",1);
									val.put("status",-1);
									val.put("type",1);
									val.put("body",body);
									//̰ȵ
									context.getContentResolver().insert(Uri.parse("content://sms/inbox"), val);

									cursor2.close();

								}
								else{	// Ÿ ġ
									sbody=cursor2.getString(cursor2.getColumnIndexOrThrow("body"));


									Log.d("mytag","1"+sbody+"="+body);
									if(sbody.compareTo(body)!=0){
										Log.d("mytag","2");
										Log.d("mytag","3");
										//Toast.makeText(context, sbody+body, Toast.LENGTH_LONG).show();
										ContentValues val = new ContentValues();
										val.put("address",str);
										val.put("date",date );
										val.put("read",1);
										val.put("status",-1);
										val.put("type",1);
										val.put("body",body);
										//̰ȵ
										context.getContentResolver().insert(Uri.parse("content://sms/inbox"), val);

										cursor2.close();
									}
								}
							}

							Log.d("hay","1");
							PendingIntent pi = PendingIntent.getActivity(context, 0, i,PendingIntent.FLAG_ONE_SHOT );
							Log.d("hay","2");
							//
							//  ű Ȯϰ
							SharedPreferences pref = context.getSharedPreferences("prefa",0);
							if(pref.getBoolean("save_option_receive", true)){
								try {
									pi.send();
								} catch (CanceledException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
							}
						}
					},1000);
		}
	} 


}